<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->

<mat-card fxLayout="column" fxFlex class="card-artifact-deployment">
  <ngx-hover-opacity [isHoverVisible]="!container.isReachable" class="deploy-artifact">
    <app-upload
      #deployArtifact
      acceptedFileType=".zip"
      [title]="getTitle()"
      [message]="'Choose artifact (Component, Service Assembly or Shared Library):'"
      [uploadStatus]="artifactUploadProgress"
      [error]="getArtifactDeploymentError()"
      [disabled]="isDisabledDeployArtifact()"
      [isFileParsed]="isFileParsed"
      (evtUploadFile)="deploy($event.selectedFileInformation.file)"
      (evtFileSelected)="fileSelected($event.file)"
      (evtResetFile)="cancelSelectedFile()"
      >
      <ng-template updateFileInformation>
        <form
          *ngIf="artifact.type === 'component'"
          novalidate
          [formGroup]="updateComponentDeployInfoFormGroup"
        >
          <div fxLayout="column" fxLayout.gt-md="row" fxLayoutAlign.gt-md="start center">
            <div fxFlex.gt-md="49" fxFlex="100">
              <mat-form-field appearance="outline" floatLabel="always" fxFlexFill class="comp-name-form-field">
                <mat-label>Name</mat-label>
                <input
                  type="text"
                  matInput
                  placeholder="{{artifact.name}}"
                  formControlName="name"
                  [appFocusInputIfLargeScreen]="canFocus"
                >
                <button
                  *ngIf="updateComponentDeployInfoFormGroup.get('name')"
                  matSuffix
                  mat-icon-button
                  color="primary"
                  aria-label="Clear"
                  [disabled]="isEditingSl()"
                  (click)="this.updateComponentDeployInfoFormGroup.get('name').setValue('')"
                  class="btn-clear-comp-name"
                >
                  <mat-icon>close</mat-icon>
                </button>

                <mat-error class="error-comp-name-input">
                  This name already exists in {{container.name}}
                </mat-error>
              </mat-form-field>
            </div>
          </div>

          <p>
            <span class="mat-body-2">About component dependencies</span>
          </p>

          <div *ngIf="dataSource !== null && isFileParsed" class="wrapper-table-sls">
            <app-message
              *ngIf="dataSource.data.length > 0 && countSlsNotInContainer > 0 && !isEditingSl()"
              type="warning"
              msg="Shared libraries with a red led are not in this container."
              [isClosable]="false"
              [isFullWidth]="true"
              class="warning-red-led"
            ></app-message>

            <app-message
              *ngIf="dataSource.data.length > 0 && countSlsNotInContainer === 0 && !isEditingSl()"
              type="success"
              msg="All the shared libraries are in this container."
              [isClosable]="false"
              [isFullWidth]="true"
              class="success-all-sls"
            ></app-message>

            <app-message
              *ngIf="dataSource.data.length === 0"
              type="info"
              msg="There are no shared libraries."
              [isClosable]="false"
              [isFullWidth]="true"
              class="info-no-sls"
            ></app-message>

            <ngx-hover-opacity
              [isHoverVisible]="updateComponentDeployInfoFormGroup.get('name').hasError('isKeyPresentInObject')"
              class="already-in-container"
            >
              <table
                *ngIf="dataSource.data.length"
                mat-table
                fxLayout="column"
                [dataSource]="dataSource"
                class="comp-shared-libraries-table"
              >
                <!-- Name Column -->
                <ng-container matColumnDef="name">
                  <th
                    mat-header-cell
                    *matHeaderCellDef
                    fxFlex="35"
                    fxFlex.gt-md="25"
                    fxLayout="row"
                    fxLayoutAlign="start center"
                  >
                    Name
                  </th>
                  <td mat-cell *matCellDef="let sl; let i = index" fxFlex="35" fxFlex.gt-md="25" fxLayout="row" fxLayoutAlign="start center" class="cell-name">
                    <span *ngIf="currentSlBeingEdited !== i; else slNameEdit" fxFlexFill fxLayout="row" fxLayoutAlign="start center">
                      <mat-icon color="primary" svgIcon="sl" fxFlex="10" class="margin-right-x1"></mat-icon>
                      <span class="sl-name ellipsis" title="{{ sl.name }}">{{ sl.name }}</span>
                    </span>

                    <ng-template #slNameEdit>
                      <mat-form-field class="override-sl-name-form-field ellipsis">
                        <input
                          type="text"
                          matInput
                          formControlName="slName"
                          [ngModel]="currentSl.name"
                          (ngModelChange)="currentSl.name = $event"
                          required
                        >
                        <mat-error>Required!</mat-error>
                      </mat-form-field>
                    </ng-template>
                  </td>
                </ng-container>

                <!-- Version Column -->
                <ng-container matColumnDef="version">
                  <th
                    mat-header-cell
                    *matHeaderCellDef
                    fxFlex="25"
                    fxLayout="row"
                    fxLayoutAlign="center center"
                  >
                    Version
                  </th>
                  <td mat-cell *matCellDef="let sl; let i = index" fxFlex="25" fxLayout="row" fxLayoutAlign="center center">
                    <span *ngIf="currentSlBeingEdited !== i; else slVersionEdit" title="{{ sl.version }}" class="sl-version ellipsis">
                      {{ sl.version }}
                    </span>

                    <ng-template #slVersionEdit>
                      <mat-form-field class="override-sl-version-form-field ellipsis">
                        <input
                          type="text"
                          matInput
                          formControlName="slVersion"
                          [ngModel]="currentSl.version"
                          (ngModelChange)="currentSl.version = $event"
                          required
                        >
                        <mat-error>Required!</mat-error>
                      </mat-form-field>
                    </ng-template>
                  </td>
                </ng-container>

                <!-- Status Column -->
                <ng-container matColumnDef="status">
                  <th
                    mat-header-cell
                    *matHeaderCellDef
                    fxFlex="15"
                    fxFlex.gt-md="25"
                    fxLayout="row"
                    fxLayoutAlign="center center"
                  >
                    Status
                  </th>
                  <td mat-cell *matCellDef="let sl; let i = index" fxFlex="15" fxFlex.gt-md="25" fxLayout="column" fxLayoutAlign="center center" class="cell-status">
                    <div *ngIf="currentSlBeingEdited !== i">
                      <app-led *ngIf="slIsInCurrentContainer[i]; else uninstalled" color="green" matTooltip="Installed" matTooltipPosition="after"></app-led>

                      <ng-template #uninstalled>
                        <app-led color="red" matTooltip="Uninstalled" matTooltipPosition="after"></app-led>
                      </ng-template>
                    </div>
                  </td>
                </ng-container>

                <!-- Actions Column -->
                <ng-container matColumnDef="actions">
                  <th
                    mat-header-cell
                    *matHeaderCellDef
                    fxFlex="25"
                    fxLayout="row"
                    fxLayoutAlign="end center"
                  >
                    Actions
                  </th>
                  <td mat-cell *matCellDef="let sl; let i = index" fxFlex="25" fxLayout="column" fxLayoutAlign="center end">
                    <span *ngIf="!isEditingSl(); else slActionsEdit" fxLayout="row" fxLayoutAlign="end center">
                      <button mat-icon-button matTooltip="Edit" (click)="editSharedLibrary(i)" class="btn-edit-sl">
                        <fa-icon icon="pencil-alt" class="icon-x1"></fa-icon>
                      </button>
                      <button mat-icon-button matTooltip="Delete" (click)="deleteSharedLibrary(i)" class="btn-delete-sl">
                        <fa-icon icon="trash-alt" class="icon-x1"></fa-icon>
                      </button>
                    </span>
                    <ng-template #slActionsEdit>
                      <span *ngIf="currentSlBeingEdited === i">
                        <button
                          *ngIf="updateComponentDeployInfoFormGroup.valid"
                          mat-icon-button
                          matTooltip="Save"
                          (click)="updateSharedLibrary()"
                          class="btn-save-sl"
                          >
                          <fa-icon icon="check" class="icon-x1"></fa-icon>
                        </button>
                        <button mat-icon-button matTooltip="Cancel" (click)="cancelOverrideSl()" class="btn-cancel-sl">
                          <fa-icon icon="times" class="icon-x1"></fa-icon>
                        </button>
                      </span>
                    </ng-template>

                  </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
              </table>
            </ngx-hover-opacity>

            <div fxLayout="row" class="margin-top-x1">
              <button
                mat-button
                type="button"
                color="primary"
                [disabled]="isDisabledDeployArtifact()"
                (click)="addNewSharedLibrary()"
                class="btn-add-row text-upper"
                >
                <span fxLayout="row" fxLayoutAlign="start center">
                  <fa-icon class="margin-right-x1 icon-x1" icon="plus"></fa-icon>
                  <span class="text-upper add-row-text-btn">Add shared library</span>
                </span>
              </button>
            </div>

          </div>
        </form>

        <form
          *ngIf="artifact.type === 'service-assembly'"
          fxLayout="column"
          fxLayout.gt-md="row"
          fxLayoutAlign.gt-md="start center"
          novalidate
          [formGroup]="updateServiceAssemblyDeployInfoFormGroup"
        >
          <div fxFlex.gt-md="49" fxFlex="100">
            <mat-form-field appearance="outline" floatLabel="always" fxFlexFill class="sa-name-form-field">
              <mat-label>Name</mat-label>
              <input
                type="text"
                matInput
                placeholder="{{artifact.name}}"
                formControlName="name"
                [appFocusInputIfLargeScreen]="canFocus"
              >
              <button
                *ngIf="updateServiceAssemblyDeployInfoFormGroup.get('name')"
                matSuffix
                mat-icon-button
                color="primary"
                aria-label="Clear"
                (click)="this.updateServiceAssemblyDeployInfoFormGroup.get('name').setValue('')"
                class="btn-clear-sa-name"
              >
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </form>

        <form
          *ngIf="artifact.type === 'shared-library'"
          fxLayout="column"
          fxLayout.gt-md="row"
          fxLayoutAlign.gt-md="space-between center"
          novalidate
          [formGroup]="updateSharedLibraryDeployInfoFormGroup"
        >
          <div fxFlex.gt-md="49" fxFlex="100">
            <mat-form-field appearance="outline" floatLabel="always" fxFlexFill class="sl-name-form-field">
              <mat-label>Name</mat-label>
              <input
                type="text"
                matInput
                placeholder="{{artifact.name}}"
                formControlName="name"
                [appFocusInputIfLargeScreen]="canFocus"
                [errorStateMatcher]="slErrorStateMatcher"
              >
              <button
                *ngIf="updateSharedLibraryDeployInfoFormGroup.get('name')"
                matSuffix
                mat-icon-button
                color="primary"
                aria-label="Clear"
                (click)="this.updateSharedLibraryDeployInfoFormGroup.get('name').setValue('')"
                class="btn-clear-sl-name"
              >
                <mat-icon>close</mat-icon>
              </button>

              <mat-error class="error-sl-name-input">
                This name already exists in {{container.name}}
              </mat-error>
            </mat-form-field>
          </div>
          <div fxFlex.gt-md="49" fxFlex="100">
            <mat-form-field appearance="outline" floatLabel="always" fxFlexFill class="sl-version-form-field">
              <mat-label>Version</mat-label>
              <input
                type="text"
                matInput
                placeholder="{{artifact.version}}"
                formControlName="version"
                [errorStateMatcher]="slErrorStateMatcher"
              >
              <button
                *ngIf="updateSharedLibraryDeployInfoFormGroup.get('version')"
                matSuffix
                mat-icon-button
                color="primary"
                aria-label="Clear"
                (click)="this.updateSharedLibraryDeployInfoFormGroup.get('version').setValue('')"
                class="btn-clear-sl-version"
              >
                <mat-icon>close</mat-icon>
              </button>

              <mat-error class="error-sl-version-input">
                This version already exists in {{container.name}}
              </mat-error>
            </mat-form-field>
          </div>
        </form>
      </ng-template>
    </app-upload>
  </ngx-hover-opacity>
</mat-card>
